<?php

namespace Meanbee\VipMembership\Setup;

use Magento\Framework\Setup\ModuleContextInterface;
use Magento\Framework\Setup\SchemaSetupInterface;
use Magento\Framework\Setup\UninstallInterface;
use Magento\Eav\Setup\EavSetupFactory;
use Magento\Catalog\Model\Product;
use Magento\Customer\Model\Customer;

class Uninstall implements UninstallInterface
{
    /**
     * EAV setup factory
     *
     * @var EavSetupFactory
     */
    private $eavSetupFactory;

    /**
     * Init
     *
     * @param EavSetupFactory $eavSetupFactory
     */
    public function __construct(EavSetupFactory $eavSetupFactory)
    {
        $this->eavSetupFactory = $eavSetupFactory;
    }

    /**
     * @inheritDoc
     */
    public function uninstall(SchemaSetupInterface $setup, ModuleContextInterface $context)
    {
        $setup->startSetup();

        /** @var \Magento\Eav\Setup\EavSetup $eavSetup */
        $eavSetup = $this->eavSetupFactory->create(['setup' => $setup]);

        // Remove product attributes
        $eavSetup->removeAttribute(Product::ENTITY, 'vip_length');
        $eavSetup->removeAttribute(Product::ENTITY, 'vip_length_unit');

        // Remove customer attributes
        $eavSetup->removeAttribute(Customer::ENTITY, 'vip_expiry');
        $eavSetup->removeAttribute(Customer::ENTITY, 'vip_order_id');

        $setup->endSetup();
    }

}
